/*
 * X11 Hints Utility Library 
 *
 * (c) Ken Lynch 2001
 *
 * Distributed under the terms of the GPL
 *
 * See COPYING for more details
 *
 */

#ifndef __HINTS_H
#define __HINTS_H

#include <X11/Xatom.h>

#define MWM_HINTS_DECORATIONS		(1L<<1)
#define MWM_DECOR_ALL			(1L<<0)
#define MWM_DECOR_BORDER		(1L<<1)
#define MWM_DECOR_TITLE			(1L<<3)
#define MWM_DECOR_MAXIMIZE		(1L<<6)

#define WIN_STATE_STICKY		(1L<<0)
#define WIN_STATE_MAXIMIZED_VERT	(1L<<2)
#define WIN_STATE_MAXIMIZED_HORIZ	(1L<<3)
#define WIN_STATE_MAXIMIZED		((1L<<2)|(1L<<3))
#define WIN_STATE_SHADED		(1L<<5)

#define WIN_HINTS_SKIP_FOCUS		(1L<<0)
#define WIN_HINTS_SKIP_TASKBAR		(1L<<2)

#define WIN_LAYER_DESKTOP		0
#define WIN_LAYER_BELOW			2
#define WIN_LAYER_NORMAL		4
#define WIN_LAYER_ONTOP			6
#define WIN_LAYER_DOCK			8

typedef struct
{
    CARD32 flags;
    CARD32 functions;
    CARD32 decorations;
    INT32 inputMode;
    CARD32 status;
}
PropMwmHints;

extern Atom wm_state, wm_change_state, wm_delete_window, wm_protocols;
extern Atom motif_wm_hints;
extern Atom win_hints, win_state, win_client_list, win_layer, win_workspace,
    win_workspace_count, win_desktop_button_proxy, win_supporting_wm_check,
    gnome_panel_desktop_area;

void initICCCMHints(Display *);
long getWMState(Display *, Window);
void setWMState(Display *, Window, long state);
void initMotifHints(Display *);
PropMwmHints *getMotifHints(Display *, Window);
void initGnomeHints(Display *);
int getGnomeHint(Display *, Window, Atom, long *);
void setGnomeHint(Display *, Window, Atom, long);
void getGnomeDesktopMargins(Display *, CARD32 *);

#endif /* __HINTS_H */
