/*
 * X11 I18N Support Library
 *
 * Adapted from the TWM I18N patch
 *
 * by Tomohiro Kubota
 *
 * Distributed under the terms of the GPL
 *
 * See COPYING for more details
 *
 */

#ifndef __I18N_H
#define __I18N_H

#include <X11/Xlocale.h>

typedef struct
{
    XFontStruct *font;
    XFontSet fontset;
    int height;
    int ascent;
    int descent;
}
MyFont;

extern int use_fontset;
int getFont(Display *, MyFont *, char *);
void freeFont(Display *, MyFont *);
void drawString(Display *, Drawable, MyFont *, GC, int, int, char *);
int getTextWidth(char *, MyFont *);
void getWindowName(Display *, Window, char **);

#endif /* __I18N_H */
