/*
 * Oroborus Window Manager
 *
 * (c) Ken Lynch 2001
 *
 * Distributed under the terms of the GPL
 *
 * See COPYING for more details
 *
 */

#include "oroborus.h"

void workspaceSwitch(int new_ws, Client * c2)
{
    Client *c, *f = NULL;
    int i;

#ifdef DEBUG
    printf("entering workspaceSwitch\n");
#endif

    if(new_ws < 0 && wrap_workspaces)
        new_ws = workspace_count - 1;
    if(new_ws > workspace_count - 1 && wrap_workspaces)
        new_ws = 0;
    if(new_ws < 0 || new_ws > workspace_count - 1 || new_ws == workspace)
        return;

    f = clientGetFocus();
    if(f)
        f->focus = True;

    if(c2)
    {
        setGnomeHint(dpy, c2->window, win_workspace, new_ws);
        c2->win_workspace = new_ws;
    }

    setGnomeHint(dpy, root, win_workspace, new_ws);
    workspace = new_ws;
    for(c = clients, i = 0; i < client_count; c = c->next, i++)
    {
        if(c->win_state & WIN_STATE_STICKY)
            clientSetWorkspace(c, new_ws);
        else
        {
            if(c->win_workspace == new_ws &&
               getWMState(dpy, c->window) != IconicState)
            {
                clientShow(c, False);
                if(c->focus)
                    f = c;
                c->focus = False;
            }
            else
                clientHide(c, False);
        }
    }
    setGnomeHint(dpy, root, win_workspace, new_ws);

    if(c2)
        f = c2;
    clientSetFocus(f, True);
}

void workspaceSetCount(int count)
{
    Client *c;
    int i;

#ifdef DEBUG
    printf("entering workspaceSetCount\n");
#endif

    if(count < 1)
        count = 1;
    if(count == workspace_count)
        return;

    setGnomeHint(dpy, root, win_workspace_count, count);
    workspace_count = count;

    for(c = clients, i = 0; i < client_count; c = c->next, i++)
        if(c->win_workspace > count - 1)
            clientSetWorkspace(c, count - 1);

    if(workspace > count - 1)
        workspaceSwitch(count - 1, NULL);
}
